/*
File tic.js
@Description - tic tac toe game logic and implementaion

 */
var xBoard = 0;
var oBoard = 0;
var begin = true;
var context;
var width, height;
var position_arr = [{x:444,y:60},{x:577,y:60},{x:706,y:60},{x:444,y:190},{x:577,y:190},{x:706,y:190},{x:444,y:323},{x:577,y:323},{x:706,y:323}];
var bit_arr = [{x:0,y:0},{x:1,y:0},{x:2,y:0},{x:0,y:1},{x:1,y:1},{x:2,y:1},{x:0,y:2},{x:1,y:2},{x:2,y:2}];
var position_index = 0;

/*
Function paintBoard()
@param -none
@Description -creates the tic tac toe game board and marks the first play by TV.
Returns -void
 */
function paintBoard() {
	gameStarted = true;
	gameEnded = false;
	$("#highlight").css("display", "block");
	$("#highlight").css("left", position_arr[position_index].x);
	$("#highlight").css("top", position_arr[position_index].y);
	$("#highlight").on({
		click : function (event) {
			selectSquare();
		}
	})

	$("#board").on({
		mousemove : function (e) {

			var y = Math.floor(e.offsetY / (height / 3));
			var x = Math.floor(e.offsetX / (width / 3));
			if (y == 0) {
				position_index = x;
			} else if (y == 1) {
				position_index = x + y + 2;
			} else if (y == 2) {
				position_index = x + y + 4;
			}
			if (!gameEnded) {
				$("#highlight").css("display", "block");
				$(".main_btn li").removeClass("btn_focus");
				$(".main_btn li ").addClass("btn_default");
			}
			$("#highlight").css("left", position_arr[position_index].x);
			$("#highlight").css("top", position_arr[position_index].y);

		}
	})
	var board = document.getElementById('board'); // $('#board')
	width = board.width;
	height = board.height;
	context = board.getContext('2d');

	context.beginPath();
	context.strokeStyle = "rgba(255,0,0,0)";
	context.lineWidth = 1;

	context.moveTo(2, 0);
	context.lineTo(2, height);

	context.moveTo((width / 3), 0);
	context.lineTo((width / 3), height);

	context.moveTo((width / 3) * 2, 0);
	context.lineTo((width / 3) * 2, height);

	context.moveTo(width - 2, 0);
	context.lineTo(width - 2, height);

	context.moveTo(0, 2);
	context.lineTo(width, 2);

	context.moveTo(0, (height / 3));
	context.lineTo(width, (height / 3));

	context.moveTo(0, (height / 3) * 2);
	context.lineTo(width, (height / 3) * 2);

	context.moveTo(0, height - 2);
	context.lineTo(width, height - 2);

	context.stroke();
	context.closePath();
	if (begin) {
		var ini = Math.abs(Math.floor(Math.random() * 9 - 0.1));
		markBit(1 << ini, 'O');
		begin = false;

	} else {
		begin = true;
	}
}
/*
Function checkWinner()
@param -board : its either xBaord or oBoard
@Description -checks the winner .
Returns -result :Boolean
 */
function checkWinner(board) {

	var result = false;

	if (((board | 0x1C0) == board) || ((board | 0x38) == board) || ((board | 0x7) == board) || ((board | 0x124) == board) || ((board | 0x92) == board) || ((board | 0x49) == board) || ((board | 0x111) == board) || ((board | 0x54) == board)) {

		result = true;
	}
	return result;
}
/*
Function paintX()
@param - x,y : position of selected box.
@Description - marks user play on the Board  in the beginX,beginY  .
Returns void
 */
function paintX(x, y) {
	var offsetX = (width / 3) * 0.01;
	var offsetY = (height / 3) * 0.01;
	var beginX = (x * (width / 3) + x) + offsetX;
	var beginY = (y * (height / 3) + y) + offsetY;
	// Create a new image.
	var imgX = new Image();

	// Once it's loaded draw the image on the canvas.
	imgX.addEventListener('load', function () {

		// Now resize the image: x, y, w, h.
		context.drawImage(this, beginX, beginY, 126, 126);

	}, false);

	imgX.src = 'image/play_' + selplayer.alt + '.png';
}
/*
Function paintO()
@param - x,y : position of selected box.
@Description - marks TV play on the Board  in the beginX,beginY  .
Returns void
 */
function paintO(x, y) {

	var offsetX = (width / 3) * 0.01;
	var offsetY = (height / 3) * 0.01;
	var beginX = (x * (width / 3) + x) + offsetX;
	var beginY = (y * (height / 3) + y) + offsetY;
	// Create a new image.
	var imgO = new Image();

	// Once it's loaded draw the image on the canvas.
	imgO.addEventListener('load', function () {

		// Now resize the image: x, y, w, h.
		context.drawImage(this, beginX, beginY, 126, 126);

	}, false);

	imgO.src = 'image/play_' + tv.alt + '.png';

}
/*
Function clickHandler()
@param - e : event.
@Description - Click on the box handler  .
Returns -void
 */
function clickHandler(e) {

	var y = Math.floor(e.offsetY / (height / 3));
	var x = Math.floor(e.offsetX / (width / 3));

	var bit = (1 << x + (y * 3));
	clickSquare(bit)
}
/*
Function checkNobody()
@param -none
@Description - Checks for winner and displays the appropriate message .
Returns  -Boolean
 */
function checkNobody() {
	if ((xBoard | oBoard) == 0x1FF) {
		if (checkWinner(xBoard)) {
			playSound(4);
			$("#selectText p").html("Congrats You win!!");
			removeHandlers();
			return;
		}
		if (checkWinner(oBoard)) {
			playSound(3);
			$("#selectText p").html("Sorry You Lose!");
			removeHandlers();
			return;
		}
		$("#selectText p").html("Nobody wins!!!");
		playSound(3);
		removeHandlers();
		return true;
	}
	return false;
}
/*
Function removeHandlers()
@param -none
@Description - Removes  all the handlers and resets the display. .
Returns  -none
 */
function removeHandlers() {
	$("#selectText").addClass("shake");
	$("#board").off("click");
	$("#restart").css("display", "block");
	backHighlight = 1;
	$("#highlight").off("click");
	$("#restart").off("click");
	$("#highlight").css("display", "none");
	gameStarted = false;
	gameEnded = true;
	$("#btn_restart").removeClass("button").addClass("buttonSelected");
	$("#restart").on("click", function (event) {
		restart();
	});
	$("#restart").on("mouseenter mouseleave", function (event) {
		highlightPrevious();
	});

}
/*
Function restart()
@param -none
@Description - Restarts the game and draws the fresh board .
Returns  -none
 */
function restart() {
	$("#restart").css("display", "none");
	$("#selectText").removeClass("shake");
	$("#selectText p").html("Play Now");
	context.clearRect(0, 0, width, height);
	xBoard = 0;
	oBoard = 0;
	backHighlight = 3;
	paintBoard();
}
/*
Function isEmpty()
@param -xBoard :user box, oBoard:TV box, bit:current box
@Description - Checks the selected box in the boarsd is empty or not .
Returns  -Boolean
 */
function isEmpty(xBoard, oBoard, bit) {
	return (((xBoard & bit) == 0) && ((oBoard & bit) == 0));
}
/*
Function simulate()
@param -xBoard :user box, oBoard:TV box, bit:current box
@Description - simulate the next move by TV.
Returns  -bit : the next location to mark the play.
 */
function simulate(oBoard, xBoard) {

	var ratio = 0;

	var bit = 0;
	for (var i = 0; i < 9; i++) {

		var cBit = 1 << i;

		if (isEmpty(xBoard, oBoard, cBit)) {

			if (checkWinner(oBoard | cBit)) {
				bit = cBit;
				break;
			} else if (checkWinner(xBoard | cBit)) {
				bit = cBit;
			}
		}
	}

	if (bit == 0) {
		for (var i = 0; i < 9; i++) {
			var cBit = 1 << i;

			if (isEmpty(xBoard, oBoard, cBit)) {
				var result = think(oBoard, xBoard, 'X', 0, 1)
					if (ratio == 0 || ratio < result) {
						ratio = result;
						bit = cBit;
					}
			}
		}
	}
	return bit;
}
/*
Function think()
@param -xBoard :user box, oBoard:TV box,player:curPlayer, bit:current box ,ratio
@Description - simulate the next move by TV.
Returns  - best : the next best location to mark the play.
 */
function think(oBoard, xBoard, player, bit, ratio) {

	if (player == 'O') {
		oBoard = oBoard | bit;
	} else {
		xBoard = xBoard | bit;
	}

	if (checkWinner(oBoard)) {
		ratio *= 1.1;
		return ratio;

	} else if (checkWinner(xBoard)) {

		ratio *= 0.7;
		return ratio;

	} else {
		var best = 0;
		ratio *= 0.6;

		for (var i = 0; i < 9; i++) {

			if (isEmpty(xBoard, oBoard, 1 << i)) {

				var newRatio = think(oBoard, xBoard, player == 'O' ? 'X' : 'O', 1 << i, ratio);

				if (best == 0 || best < newRatio) {
					best = newRatio;
				}
			}
		}

		return best;
	}
}
/*
Function markBit()
@param -markBit :the bit to be marked, player:curPlayer,
@Description - mark the actual play.
Returns  - void.
 */
function markBit(markBit, player) {

	var bit = 1;
	var posX = 0,
	posY = 0;
	while ((markBit & bit) == 0) {
		bit = bit << 1;
		posX++;
		if (posX > 2) {
			posX = 0;
			posY++;
		}
	}

	if (player == 'O') {
		oBoard = oBoard | bit;
		paintO(posX, posY);

	} else {
		xBoard = xBoard | bit;
		paintX(posX, posY);
	}
}
/*
Function play()
@param -none
@Description - start play function.
Returns  - void.
 */
function play() {
	var bestBit = simulate(oBoard, xBoard);
	markBit(bestBit, 'O');

}
/*
Function squareMove(dir)
@param -dir :direction of the movememnt
@Description - Moves around the selected box highlight when mouse if off.
Returns  - void.
 */
function squareMove(dir) {
	if (backHighlight != 2) {

		switch (dir) {
		case "up":
			position_index = position_index - 3;
			if (position_index < 0) {
				position_index = position_index + 3;
				highlightBack();
			}
			break;
		case "down":
			position_index = position_index + 3;
			if (position_index > position_arr.length - 1) {
				position_index = position_index - position_arr.length;
			}
			break;
		case "left":
			if (position_index > 0) {
				position_index--;
			} else {
				position_index = position_arr.length - 1;
			}
			break;
		case "right":
			if (position_index < position_arr.length - 1) {
				position_index++;
			} else {
				position_index = 0;
			}
			break;
		}
		$("#highlight").css("left", position_arr[position_index].x);
		$("#highlight").css("top", position_arr[position_index].y);
	}
}
/*
Function selectSquare()
@param -none
@Description - select the current square when mouse is off and enter is pressed.
Returns  - void
 */
function selectSquare() {
	var y = bit_arr[position_index].y;
	var x = bit_arr[position_index].x;
	var bit = (1 << x + (y * 3));
	playSound(2);
	clickSquare(bit);
}
/*
Function clickSquare()
@param -xBoard : bit:current box;
@Description - The actaul selection happens here when mouse is off.
Returns  - best : the next best location to mark the play.
 */
function clickSquare(bit) {
	if (isEmpty(xBoard, oBoard, bit)) {

		markBit(bit, 'X')

		if (!checkNobody()) {
			if (checkWinner(xBoard)) {
				playSound(4);
				$("#selectText p").html("Congrats You win!!");
				removeHandlers()

			} else {

				play();
				if (!checkNobody()) {

					if (checkWinner(oBoard)) {
						playSound(3);
						$("#selectText p").html("Sorry You Lose!");
						removeHandlers()

					}
				}
			}
		}
	}
}
